<license>
  (c) 2010-present DEMOS plan GmbH.

  This file is part of the package demosplan,
  for more information see the license file.

  All rights reserved
</license>

<template>
  <dp-tabs
    v-if="allComponentsLoaded"
    :active-id="activeTabId"
    use-url-fragment
    @change="setActiveTabId">
    <dp-tab
      v-for="(option, index) in availableImportOptions"
      :key="index"
      :id="option.name"
      :label="Translator.trans(option.title)">
      <slot>
        <keep-alive>
          <component
            class="u-mt"
            :is="option.name" />
        </keep-alive>
      </slot>
    </dp-tab>
  </dp-tabs>

  <dp-loading
    v-else
    class="u-mv" />
</template>

<script>
import { checkResponse, dpRpc, DpLoading, DpTab, DpTabs, hasAnyPermissions } from '@demos-europe/demosplan-ui'
import AdministrationImportNone from './AdministrationImportNone'
import ExcelImport from './ExcelImport/ExcelImport'
import StatementFormImport from './StatementFormImport/StatementFormImport'

export default {
  name: 'AdministrationImport',

  components: {
    AdministrationImportNone,
    DpLoading,
    DpTab,
    DpTabs,
    ExcelImport,
    StatementFormImport
  },

  provide () {
    return {
      currentUserId: this.currentUserId,
      newestInternId: this.newestInternId,
      procedureId: this.procedureId,
      submitTypeOptions: this.submitTypeOptions,
      tags: this.tags,
      usedInternIds: this.usedInternIds
    }
  },

  props: {
    currentUserId: {
      type: String,
      required: true
    },

    newestInternId: {
      type: String,
      required: false,
      default: '-'
    },

    procedureId: {
      type: String,
      required: true
    },

    submitTypeOptions: {
      type: Array,
      required: false,
      default: () => []
    },

    tags: {
      type: Array,
      required: false,
      default: () => []
    },

    usedInternIds: {
      type: Array,
      required: false,
      default: () => []
    }
  },

  data () {
    return {
      activeTabId: '',
      allComponentsLoaded: false,
      asyncComponents: []
    }
  },

  computed: {
    availableImportOptions () {
      return [
        {
          name: ExcelImport.name,
          permissions: ['feature_statements_import_excel', 'feature_segments_import_excel'],
          title: 'import.options.xls'
        },
        {
          name: StatementFormImport.name,
          permissions: ['feature_simplified_new_statement_create'],
          title: 'import.options.form'
        }
      ].filter((component) => {
        return hasAnyPermissions(component.permissions)
      }).concat(this.asyncComponents)
    }
  },

  methods: {
    setActiveTabId (id) {
      if (id) {
        window.localStorage.setItem('importCenterActiveTabId', id)
      }

      if (window.localStorage.getItem('importCenterActiveTabId')) {
        this.activeTabId = window.localStorage.getItem('importCenterActiveTabId')
      }
    },

    loadComponents (hookName) {
      const params = {
        hookName: hookName
      }

      return dpRpc('addons.assets.load', params)
        .then(response => checkResponse(response))
        .then(response => {
          const result = response[0].result

          for (const key of Object.keys(result)) {
            const addon = result[key]
            const contentKey = addon.entry + '.umd.js'
            const content = addon.content[contentKey]

            /**
             * The evaluation of the response content automatically binds the vue component
             * to the window object. This way we can implement it in vue's internals to render
             * the component.
             */
            eval(content)
            this.$options.components[addon.entry] = window[addon.entry].default

            this.asyncComponents.push({
              name: addon.entry,
              title: addon.options.title
            })
          }
        })
    }
  },

  mounted () {
    Promise.allSettled([
      this.loadComponents('import.tabs'),
      this.loadComponents('email.import')
    ])
      .then(() => {
        this.allComponentsLoaded = true
        this.setActiveTabId()
      })
  }
}
</script>
